# Monarch Hook Plugin

## Installation

```console
composer require monarch/monarch_hook_plugin
```

## Example Usage

```php
namespace Drupal\example_module\Plugin\Hook;

use Drupal\monarch_hook_plugin\Plugin\Hook\HookBase;

/**
 * Example hook plugin.
 *
 * @Hook(
 *   id = "example_module_example_hook",
 * )
 */
class ExampleHook extends HookBase {

  /**
   * Implements hook_node_load().
   */
  public function hookNodeLoad($nodes) {
    // Do your thing.
  }

}
```

```php
namespace Drupal\example_module\Plugin\Hook;

use Drupal\monarch_hook_plugin\Plugin\Hook\HookBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Example hook alter plugin.
 *
 * @Hook(
 *   id = "example_module_example_alter",
 * )
 */
class ExampleAlter extends HookBase {

  /**
   * Implements hook_form_alter().
   */
  public function hookFormUserFormAlter(&$form, FormStateInterface $form_state, $form_id) {
    // Do your thing.
  }

}
```

```php
namespace Drupal\example_module\Plugin\Hook;

use Drupal\monarch_hook_plugin\Plugin\Hook\HookBase;

/**
 * Example hook preprocess plugin.
 *
 * @Hook(
 *   id = "example_module_example_preprocess",
 * )
 */
class ExamplePreprocess extends HookBase {

  /**
   * Implements hook_preprocess().
   */
  public function preprocessPage(&$variables) {
    // Do your thing.
  }

  /**
   * Implements hook_preprocess().
   */
  public function hookPreprocessPage(&$variables) {
    // Also valid.
  }

}
```